//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Mon Dec  6 15:22:10 PST 1999
// Last Modified: Mon Dec  6 15:22:13 PST 1999
// Filename:      ...improv/doc/gui/linux/qt/examples/midiscope/main.cpp
// Syntax:        C++; qt 2.02
// $Smake:        g++ -DLINUX -O3 %
//                -I/usr/lib/qt-1.44/include %
//                -I/home/craig/improvHCI/include -o midiscope %f %
//                MainWidget.cpp %
//                -L/home/craig/improvHCI/lib -limprov %
//                -lpthread %
//                -L/usr/lib/qt-1.44/lib -lqt 
//

#include <qapplication.h>
#include "MainWidget.h"
#include "improv.h"
#include <iostream.h>

// function declarations
void midiInputCallback(int port);  // for MIDI processing event loop

// global variables:
MidiInput  midi;            // MIDI input
MainWidget* silly;


/////////////////////////////////////////////////////////////////////////////

int main(int argc, char** argv) {
   QApplication application(argc, argv);
   MainWidget mainWidget;      // main qt window display
   silly = &mainWidget;
   application.setMainWidget(&mainWidget);
   mainWidget.show();
   midi.setCallback(midiInputCallback);
   int flag = application.exec();
   return flag;
}

/////////////////////////////////////////////////////////////////////////////


//////////////////////////////
//
// midiInputCallback -- this function is called whenever a 
//    MIDI message is received.
//

void midiInputCallback(int port) {
   static MidiMessage message;
   if (midi.getCount() > 0) {
      message = midi.extract();
      silly->midi(message.p0(), message.p1(), message.p2());
   }
}




